#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "cui.h"
#include "esc.h"
#include "handler.h"
#include "label.h"
#include "button.h"
#include "ckbox.h"
#include "radio.h"
#include "dialog.h"
#include "menu.h"
#include "etext.h"
#include "tab.h"
#include "fillbtn.h"
#include "scbar.h"
#include "scpanel.h"
#include "term.h"
#include "timer.h"

int
joke_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm, b2 = lb->children, b1 = b2->next;
	char *s = cui_button_str_get(obj);

	if(strcmp(s, "reboot") == 0 || strcmp(s, "power off") == 0){
		cui_label_str_set(lb, "It's a joke");
		cui_button_str_set(b1, "sorry");
		cui_x_set(b1, cui_x2(lb) + 1);
		cui_hide(b2);
		cui_focus_set(b1);
		cui_w_set(lb, cui_x2(b1));
	}else{
		cui_hide(lb);	
		cui_focus_set(NULL);
		cui_draw(lb->parent);
		cui_quit();
	}
	return TRUE;
}

cui
joke_new(cui parent, int x, int y)
{
	cui lb = cui_label_new(parent, x, y, "system panic!");
	cui b1 = cui_button_new(lb, lb->w + 1, 0, "reboot");
	cui b2 = cui_button_new(lb, cui_x2(b1) + 1, 0, "power off");
	cui_w_set(lb, cui_x2(b2));
	cui_bind(b1, CUI_EVT_BUTTON, joke_hdr, lb);
	cui_bind(b2, CUI_EVT_BUTTON, joke_hdr, lb);
	return lb;
}

int
my_hdr(cui obj, int evt, int val, void *prm)
{
	cui joke;
	cui_simple_dialog p = (cui_simple_dialog)prm;
	cui_label_str_set(p->label, "Realy ?");
	cui_button_str_set(p->btn1, "Yes");
	cui_button_str_set(p->btn2, "No");
	cui_unbind(obj, CUI_EVT_BUTTON, my_hdr);
	joke = joke_new(((cui)p)->parent->parent->parent, 0, 4);
	cui_main(joke, joke->children->next);
	cui_del(joke);
	cui_free(joke);
	return TRUE;
}

int
my_hdr2(cui obj, int evt, int val, void *prm)
{
	cui dlg = (cui)prm;
	if(val) cui_show(dlg);
	else cui_hide(dlg);
	return TRUE;
}

int
mv_hdr(cui obj, int evt, int val, void *prm)
{
	static char buf[16];

	cui_y_set(obj, obj->y + 1);
	sprintf(buf, "%d", cui_gy(obj));
	cui_label_str_set((cui)prm, buf);
	return TRUE;
}

int
radio_hdr(cui obj, int evt, int val, void *prm)
{
	char *s = cui_radio_str_get(obj);
	if(!val) return TRUE;
	if(strcmp(s, "ON") == 0) cui_show((cui)prm);
	else if(strcmp(s, "OFF") == 0) cui_hide((cui)prm);
	else{
		cui lb = obj->parent->parent->children;
		cui_label_str_set(lb, (char *)prm);
	}
	return TRUE;
}

cui
radio_new(cui parent, int x, int y)
{
	cui panel, lb, grp, rd_on, rd_off, base, grp2, rd[4];

	panel = cui_panel_new(parent, x, y, 0, 0);
	lb = cui_label_new(panel, 1, 1, "Radio");
	grp = cui_base_new(panel, lb->x+2, cui_y2(lb), 0, 0);
	rd_on = cui_radio_new(grp, 0, 0, "ON", 0);
	rd_off = cui_radio_new(grp, cui_x2(rd_on)+1, rd_on->y, "OFF", 1);
	cui_wh_fit(grp);

	base = cui_base_new(panel, grp->x, cui_y2(grp), 0, 0);
	grp2 = cui_base_new(base, 0, 0, 0, 0);
	rd[0] = cui_radio_new(grp2, 0, 0, "ABC", 0);
	rd[1] = cui_radio_new(grp2, 0, 1, "KBS", 0);
	rd[2] = cui_radio_new(grp2, 0, 2, "MBS", 0);
	rd[3] = cui_radio_new(grp2, 0, 3, "OBC", 0);
	cui_wh_fit(grp2);
	cui_label_new(base, cui_x2(grp2)+2, 0, "     kHz");
	cui_wh_fit(base);
	cui_hide(base);

	cui_wh_fit(panel);
	cui_wh_set(panel, panel->w+1, panel->h+1);

	cui_bind(rd_on, CUI_EVT_BUTTON, radio_hdr, base);
	cui_bind(rd_off, CUI_EVT_BUTTON, radio_hdr, base);
	cui_bind(rd[0], CUI_EVT_BUTTON, radio_hdr, "1008 kHz");
	cui_bind(rd[1], CUI_EVT_BUTTON, radio_hdr, "1143 kHz");
	cui_bind(rd[2], CUI_EVT_BUTTON, radio_hdr, "1179 kHz");
	cui_bind(rd[3], CUI_EVT_BUTTON, radio_hdr, "1314 kHz");
	return panel;	
}

int
mn_long_hdr(cui obj, int evt, int val, void *prm)
{
	cui menu = (cui)prm;

	if(menu){ /* menu_btn */
		cui_show(menu);
		cui_main(menu, cui_index_to_child(menu, 0));
		cui_hide(menu);
		cui_draw(menu->parent);
		return TRUE;
	}
	/* prm == NULL (menu) */
	cui_quit();
	return TRUE;
}

cui
mn_long_new(cui parent, int x, int y)
{
	cui mn_btn = cui_menu_btn_new(parent, x, y, "LONG");
	cui menu;
	static char buf[20][16], *lst[21];
	int i;

	for(i=0; i<20; i++){
		lst[i] = buf[i];
		sprintf(lst[i], "cmd %d", i);
	}
	lst[20] = NULL;
	menu = cui_menu_new(parent, mn_btn->x, mn_btn->y+1, lst);
	cui_bind(mn_btn, CUI_EVT_BUTTON, mn_long_hdr, menu);
	cui_bind(menu, CUI_EVT_BUTTON, mn_long_hdr, NULL);
	return mn_btn;
}

int
popup_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm;
	static char buf[16];
	int last[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	sprintf(buf, "last %d/%d", val+1, last[val]);
	cui_label_str_set(lb, buf);
	return TRUE;
}

cui
big_new(cui parent, int x, int y, cui_simple_dialog *res_dlg)
{
	cui base = cui_base_new(parent, x, y, 0, 0);
	cui dlg = cui_simple_dialog_new(base, 0, 0, "Are you sure ?", "OK", "Cancel");
	cui_simple_dialog p = (cui_simple_dialog)dlg;	
	cui popup = cui_menu_popup_new(base, cui_x2(dlg)+1, cui_y2(dlg)+5, 8, 
		(char *[]){"January", "February", "March", "April", "May", "June", 
		"July", "August", "September", "October", "November", "December", NULL}, 0);
	cui lb = cui_label_new(base, cui_x2(popup)+2, popup->y, "last 1/31");

	radio_new(base, cui_x2(dlg)+1, dlg->y);
	cui_simple_dialog_new(base, dlg->x, cui_y2(dlg), "How are you ?", "^_^", "T_T");

	cui_wh_fit(base);
	cui_fill_new(base, 0, base->h + 4, base->w, 1, "bottom ... ", CUI_ATTR_NORMAL);
	cui_wh_fit(base);

	mn_long_new(base, cui_x2(dlg)+1, cui_y2(dlg)+3);

	cui_bind(p->btn1, CUI_EVT_BUTTON, my_hdr, p);
	cui_bind(popup, CUI_EVT_BUTTON, popup_hdr, lb);
	*res_dlg = p;
	return base;
}

int
mn_hdr(cui obj, int evt, int val, void *prm)
{
	if(val >= 0){
		cui item = cui_index_to_child(obj, val);
		char *s = cui_menu_item_str_get(item);
		cui_label_str_set((cui)prm, s);
	}				  
	cui_quit();
	return TRUE;
}

int
mn_btn_hdr(cui obj, int evt, int val, void *prm)
{
	char *lst[] = {"Open", "Save", "Close", "Quit", NULL};
	cui menu = cui_menu_new(obj->parent, obj->x, obj->y+1, lst);

	cui_bind(menu, CUI_EVT_BUTTON, mn_hdr, prm);
	menu->flags &= ~CUI_FLG_HIDE;
	cui_main(menu, cui_menu_str_to_item(menu, "Open"));
	cui_hide(menu);
	cui_draw(menu->parent);
	cui_del(menu);
	cui_free(menu);

	if(strcmp(cui_label_str_get((cui)prm), "Quit") == 0) cui_quit();
	return TRUE;
}

int
etx_hdr(cui obj, int evt, int val, void *prm)
{
	static char buf[CUI_ETEXT_BSIZE * 2];

	sprintf(buf, "'%s'", cui_etext_str_get(obj));
	cui_label_str_set((cui)prm, buf);
	return TRUE;
}

int
sc_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm;
	static char buf[16];

	usleep(50*1000);
	sprintf(buf, "%d", val);
	cui_label_str_set(lb, buf);
	return TRUE;
}

int
in_hoge_hdr(cui obj, int evt, int val, void *prm)
{
	/* CUI_EVT_DRAW */

	FILE *fp = fopen("cui_test.c", "r");
	int y, n, w, h, si, di, i;
	char buf[1024], buf2[1024];
	int *ret = (int *)prm;

	if(fp == NULL) return TRUE;

	y = 0;
	w = 0;
	while(fgets(buf, 1024, fp)){
		si = di = 0;
		while(buf[si] && di<1024-1){
			if(buf[si] == '\n') break;
			if(buf[si] == '\t'){
				n = 1024-1-di;
				n = n > 8 ? 8 : n;
				for(i=0; i<n; i++) buf2[di++] = ' ';
				si++;
				continue;
			}
			buf2[di++] = buf[si++];
		}
		buf2[di] = '\0';
		cui_draw_str(obj, 0, y++, buf2, CUI_ATTR_NORMAL);
		n = strlen(buf2);
		if(w < n) w = n;
	}
	h = y;
	fclose(fp);
	if(ret){
		ret[0] = w;
		ret[1] = h;
	}
	return TRUE;
}

int
lb_timer_hdr(cui obj, int evt, int val, void *prm)
{
	/* CUI_EVT_TIMER */

	char *buf = (char *)prm;
	static char *ss[] = { "foo", "bar", "hoge", "fuga", NULL };
	char *s = cui_label_str_get(obj);
	int i;
	if(buf){
		int cnt = strtol(buf, NULL, 0);
		sprintf(buf, "%d", cnt+1);
		cui_label_str_set(obj, buf);
		return TRUE;
	}
	for(i=0; ss[i]; i++) if(strcmp(s, ss[i]) == 0) break;
	if(ss[i]) i++;
	if(ss[i] == NULL) i = 0;
	cui_label_str_set(obj, ss[i]);
	return TRUE;
}

int
main(int ac, char **av)
{
	int dbg_ret = cui_dbg_open(ac, av);
	cui bs = cui_scpanel_new(NULL, 0, 0, 42, 23, "cui_test");
	cui bs_view = ((cui_scpanel)bs)->view;
	cui bs_bar = cui_base_new(bs_view, 0, 1, 0, 0);
	cui lb_bar = cui_label_new(bs_bar, 1, 1, "bar");
	cui sc = cui_scbar_new(bs_bar, 1, 2, 20, 1, 30, 15);
	cui sc2 = cui_scbar_new(bs_bar, 1, 3, 20, 1, 10, 0);
	cui sc3 = cui_scbar_new(bs_bar, cui_x2(sc)+2, sc->y, 1, 16, 4, 2);
	cui sc_hoge = cui_scpanel_new(bs_view, 0, 1, 30, 15, NULL);
	cui in_hoge = cui_scpanel_sheet_get(sc_hoge);
	cui bs_term = cui_base_new(bs_view, 0, 1, 100, 100);
	cui bs_timer = cui_base_new(bs_view, 0, 1, 0, 0);
	cui lb_timer1 = cui_label_new(bs_timer, 0, 1, "0   ");
	cui lb_timer2 = cui_label_new(bs_timer, 10, 1, "not yet");
	cui lb_timer3 = cui_label_new(bs_timer, 10, 2, "not yet");
	cui base = cui_base_new(bs_view, 0, 1, 40, 20);
	cui mn_btn = cui_menu_btn_new(base, 1, 1, "File");
	cui etx = cui_etext_new(base, mn_btn->x, cui_y2(mn_btn), 8, "foo");
	cui ck = cui_ckbox_new(base, cui_x2(mn_btn)+2, 1, "Show", FALSE);
	cui mv_btn = cui_button_new(base, cui_x2(ck) + 2, ck->y, "move");
	cui mv_lb = cui_label_new(base, cui_x2(mv_btn) + 2, mv_btn->y, "");

	cui_simple_dialog p;
	cui small = cui_scpanel_new(base, 2, 3, base->w - (2 * 2), base->h - (3 + 1), "title");
	cui small2 = cui_scpanel_sheet_get(small);

	cui tab_sheets[] = { base, bs_bar, sc_hoge, bs_term, bs_timer };

	char lb_timer1_buf[16];

	big_new(small2, 0, 0, &p);
	cui_wh_fit(small2);

	cui_hide(small);
	cui_bind(mn_btn, CUI_EVT_BUTTON, mn_btn_hdr, mv_lb);
	cui_bind(etx, CUI_EVT_BUTTON, etx_hdr, mv_lb);
	cui_bind(ck, CUI_EVT_BUTTON, my_hdr2, small);
	cui_bind(mv_btn, CUI_EVT_BUTTON, mv_hdr, mv_lb);

	cui_hide(bs_bar);
	cui_wh_fit(bs_bar);
	cui_bind(sc, CUI_EVT_BUTTON, sc_hdr, lb_bar);
	cui_bind(sc2, CUI_EVT_BUTTON, sc_hdr, lb_bar);
	cui_bind(sc3, CUI_EVT_BUTTON, sc_hdr, lb_bar);

	{
		int wh[2];
		in_hoge_hdr(in_hoge, CUI_EVT_DRAW, 0, wh);
		cui_wh_set(in_hoge, wh[0], wh[1]);
	}
	cui_bind(in_hoge, CUI_EVT_DRAW, in_hoge_hdr, NULL);
	cui_hide(sc_hoge);

	cui_hide(bs_term);
	cui_terminal_new(bs_term, 0, 1, 30, 15);

	cui_hide(bs_timer);
	cui_wh_fit(bs_timer);

	strcpy(lb_timer1_buf, "0");
	cui_label_str_set(lb_timer1, lb_timer1_buf);
	cui_timer_set_bind(lb_timer1, 1000, FALSE, lb_timer_hdr, lb_timer1_buf);
	cui_timer_set_bind(lb_timer2, 200, FALSE, lb_timer_hdr, NULL);
	cui_timer_set_bind(lb_timer3, 10*1000, TRUE, lb_timer_hdr, NULL);

	cui_tab_new(bs_view, 0, 0, -1, (char *[]){"foo", "bar", "hoge", "term", "timer", NULL}, tab_sheets, 0);

	cui_main(bs, NULL);
	printf("result %s\n", p->btn_result);
	cui_free(bs);
	if(dbg_ret == 0) cui_dbg_close();
	return 0;
}

/* EOF */
