#include "dbg.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

static FILE *fp = NULL;
int cui_dbg_enable = 1;

int
cui_dbg_open(int ac, char **av)
{
	char buf[1024];	
	int i;
	char *nc_opt = "localhost 12345";

	if(fp) return 0;

	for(i=1; i<ac; i++) if(strcmp(av[i], "-dbg-en0") == 0) break;
	if(i<ac) cui_dbg_enable = 0;

	for(i=1; i<ac; i++) if(strcmp(av[i], "-dbg") == 0) break;
	if(i >= ac) return 0;

	if(i+1 < ac) nc_opt = av[i+1];
	sprintf(buf, "nc %s", nc_opt);
	if((fp = popen(buf, "w")) == NULL) return -1;
	return 0;
}

void
cui_dbg_close(void)
{
	if(fp) pclose(fp);
}

void
cui_dbg(char *fmt, ...)
{
	va_list ap;

	if(!fp) return;
	if(!cui_dbg_enable) return;
	va_start(ap, fmt);
	vfprintf(fp, fmt, ap);
	fflush(fp);
	va_end(ap);
}

/* EOF */
