#include "list.h"
#include "cui.h"
#include <stdio.h>
#include <stdlib.h>

void *
cui_list_add(cui_list *root, int data_size)
{
	cui_list p = malloc(sizeof(struct cui_list) + data_size);
	if(p == NULL) ERR("No Mem");
	p->next = *root;
	*root = p;
	return p->data;
}

void
cui_list_del(cui_list *root, void *data)
{
	cui_list p = *root, *prev=root;
	for(; p; prev=&p->next, p=p->next) if(p->data == data) break;
	if(p == NULL) return;
	*prev = p->next;
	free(p);
}

void
cui_list_del_all(cui_list *root)
{
	cui_list p = *root, next;
	for(; p; p=next){
		next = p->next;
		cui_list_del(root, p->data);
	}
}

/* EOF */
